/* pixmaps.c */

#include "pixmaps.h"

static char *chain_v_xpm[] = {
   "8 21 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   " .....  ",
   ".+++++. ",
   ".+... .+",
   ".+.+.+.+",
   ".+.+.+.+",
   ".+.+.+.+",
   ".+...+.+",
   ".+.+.+.+",
   " ..+.. +",
   "  .+.++ ",
   "  .+.+  ",
   " ..+..  ",
   ". .+.+. ",
   ".+...+.+",
   ".+.+.+.+",
   ".+.+.+.+",
   ".+.+.+.+",
   ".+...+.+",
   ".+++++.+",
   " ..... +",
   "  +++++ "
   };

static char *locked_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                ",
   "    .......     ",
   "   ..+++++..    ",
   "   .++     .+   ",
   "   .+      .+   ",
   "   .+      .+   ",
   "  ...........   ",
   "  ..+++++++..+  ",
   "  .++       .+  ",
   "  .+  ...   .+  ",
   "  .+  ...+  .+  ",
   "  .+   .++  .+  ",
   "  .+   .+   .+  ",
   "  ..    +  ..+  ",
   "  ...........+  ",
   "   +++++++++++  "
   };

static char *add_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                ",
   "                ",
   "                ",
   "       ..       ",
   "       ..+      ",
   "       ..+      ",
   "       ..+      ",
   "   ..........   ",
   "   ..........+  ",
   "    +++..+++++  ",
   "       ..+      ",
   "       ..+      ",
   "       ..+      ",
   "        ++      ",
   "                ",
   "                "
   };

static char *slide_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                ",
   "                ",
   "  ...           ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "  ...+          ",
   "   +++          ",
   "                "
   };

static char *close_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                ",
   "                ",
   "   .    ..      ",
   "   ..  ....     ",
   "    .. ...++    ",
   "    .....++     ",
   "     ...++      ",
   "     ....       ",
   "    ......      ",
   "    ..+....     ",
   "   ..++ ....    ",
   "   .++   ..++   ",
   "    +     ++    ",
   "                ",
   "                ",
   "                "
   };

static char *clone_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "    ..          ",
   "  .. +.         ",
   ".. ++ .+ ..     ",
   ".+.    .. +.    ",
   ".+.+   .++ .+   ",
   ".. +    .   .   ",
   ".++      .  .+  ",
   ".+       .+  .  ",
   " .        .   . ",
   " .+     .. +  .+",
   "  .   .. ++    .",
   "  .+...++    .. ",
   "   . ++.   .. ++",
   "    +  .+.. ++  ",
   "        . ++    ",
   "         +      "
   };

static char *translation_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "       .        ",
   "      ...       ",
   "     .....      ",
   "       .+++     ",
   "       .+       ",
   "  .    .+   .   ",
   " ..    .+   ..  ",
   "............... ",
   " ..++++.++++..++",
   "  .+   .+   .++ ",
   "   +   .+    +  ",
   "       .+       ",
   "     .....      ",
   "      ...+      ",
   "       .+       ",
   "       +        "
   };

static char *rotation_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                ",
   "    .....       ",
   "  ..+++++..     ",
   " ..++     ..    ",
   " .++       .+   ",
   ".++         .   ",
   ".+          .+  ",
   ".+          .+  ",
   ".+        ..... ",
   ".+         ...++",
   " .          .++ ",
   " ..          +  ",
   "  ..     ..     ",
   "   +.....+++    ",
   "     +++++      ",
   "                "
   };

static char *scale_xpm[] = {
   "16 16 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "       .        ",
   "      ...       ",
   "     .....      ",
   "      +.+++     ",
   "    .......     ",
   "  . .++.++.+.   ",
   " ..+.+  + .+..  ",
   "...... . ...... ",
   " ..+.++ + .+..++",
   "  .+.+ .  .+.++ ",
   "   +.......+ +  ",
   "     ++.++++    ",
   "     .....      ",
   "      ...++     ",
   "       .++      ",
   "        +       "
   };

static char *tilt_xpm[] = {
   "16 16 53 1",
   "       c None",
   ".      c #B5B5B5",
   "+      c #9D9D9D",
   "@      c #9B9B9B",
   "#      c #7F7F7F",
   "$      c #989898",
   "%      c #161616",
   "&      c #000000",
   "*      c #090909",
   "=      c #202020",
   "-      c #3F3F3F",
   ";      c #282828",
   ">      c #A9A9A9",
   ",      c #4F4F4F",
   "'      c #3D3D3D",
   ")      c #444444",
   "!      c #363636",
   "~      c #5C5C5C",
   "{      c #030303",
   "]      c #171717",
   "^      c #1A1A1A",
   "/      c #0A0A0A",
   "(      c #8A8A8A",
   "_      c #343434",
   ":      c #8D8D8D",
   "<      c #AAAAAA",
   "[      c #686868",
   "}      c #717171",
   "|      c #A2A2A2",
   "1      c #979797",
   "2      c #242424",
   "3      c #929292",
   "4      c #9C9C9C",
   "5      c #676767",
   "6      c #1F1F1F",
   "7      c #323232",
   "8      c #404040",
   "9      c #5A5A5A",
   "0      c #040404",
   "a      c #767676",
   "b      c #111111",
   "c      c #050505",
   "d      c #5E5E5E",
   "e      c #0D0D0D",
   "f      c #8B8B8B",
   "g      c #848484",
   "h      c #595959",
   "i      c #818181",
   "j      c #646464",
   "k      c #8E8E8E",
   "l      c #ACACAC",
   "m      c #A1A1A1",
   "n      c #B7B7B7",
   "                ",
   "          .+    ",
   "   @#   $%&*    ",
   " +*&= -;>,&&@   ",
   "  &&')!~{]'^#   ",
   "  %,]/( _/':<   ",
   "  [}{_| 1(!2>   ",
   "  3]~4 &  56    ",
   "   78    90}a   ",
   "   :'b9  b],%   ",
   "  #^']c d''&&.  ",
   "  @&&,}]2:^&c+  ",
   "   *&e[fg<,hi   ",
   "   j[k    1l    ",
   "   mn           ",
   "                "
   };

static char *perspective_xpm[] = {
   "23 23 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                       ",
   "                       ",
   "                       ",
   "                       ",
   "                       ",
   "        ..........     ",
   "      .. .++++++..+    ",
   "    ............ .+    ",
   "    .++++.+++++.+.+    ",
   "    .+   .+    .+.+    ",
   "    .+   .+    .+.+    ",
   "    .+   .+    .+.+    ",
   "    .+   .+    .+.+    ",
   "    .+   .........+    ",
   "    .+  . +++++.+.+    ",
   "    .+ . +     .. +    ",
   "    .+. +      ..+     ",
   "    .. +       .++     ",
   "    ............+      ",
   "     ++++++++++++      ",
   "                       ",
   "                       ",
   "                       "
   };

static char *orthographic_xpm[] = {
   "23 23 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                       ",
   "                       ",
   "                       ",
   "        ............   ",
   "       ..+++++++++..+  ",
   "      . .+       . .+  ",
   "     . +.+      . +.+  ",
   "    . + .+     . + .+  ",
   "   ............ +  .+  ",
   "   .++++.+++++.+   .+  ",
   "   .+   .+    .+   .+  ",
   "   .+   .+    .+   .+  ",
   "   .+   .+    .+   .+  ",
   "   .+   .+    .+   .+  ",
   "   .+   ............+  ",
   "   .+  . +++++.+++.++  ",
   "   .+ . +     .+ . +   ",
   "   .+. +      .+. +    ",
   "   .. +       .. +     ",
   "   ............++      ",
   "    ++++++++++++       ",
   "                       ",
   "                       "
   };

static char *volume_xpm[] = {
   "23 23 4 1",
   "       c None",
   ".      c #000000",
   "+      c #444141",
   "@      c #929292",
   "                       ",
   "        ......         ",
   "      ..      ..       ",
   "     .  ++   +  .      ",
   "    .  + +  + +  .     ",
   "    . +   ++   + .@    ",
   "   . +    ++    + .    ",
   "   . + +  ++  + + .@   ",
   "  . +   + ++ +   + .   ",
   "  . +   ++++++   + .@  ",
   "  . +   +    +   + .@  ",
   "  . +   +    +   + .@  ",
   "  . +   ++++++   + .@  ",
   "  . +   + ++ +   + .@  ",
   "   . + +  ++  + + .@@  ",
   "   . +    ++    + .@   ",
   "    . +   ++   + .@@   ",
   "    .  + +  + +  .@    ",
   "     .  +    +  .@@    ",
   "      ..      ..@@     ",
   "        ......@@@      ",
   "         @@@@@@        ",
   "                       "
   };

static char *add_pane_xpm[] = {
   "24 24 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                        ",
   "                        ",
   "          .........     ",
   "          .+++++++.+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+. . . .+    ",
   "          .+ + + +.+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "       .. .+      .+    ",
   "       ..+.+. . . .+    ",
   "       ..+.+ + + +.+    ",
   "       ..+ +      .+    ",
   "   ..........     .+    ",
   "   ..........+    .+    ",
   "    +++..+++++.....+    ",
   "       ..+.    +++.+    ",
   "       ..+.........+    ",
   "       ..+ +++++++++    ",
   "        ++              ",
   "                        "
   };

static char *clone_pane_xpm[] = {
   "24 24 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                        ",
   "    .........           ",
   "    .+++++++.+          ",
   "    .+    .........     ",
   "    .+    .+++++++.+    ",
   "    .+    .+      .+    ",
   "    .+    .+      .+    ",
   "    .+. . .+      .+    ",
   "    .+ + +.+      .+    ",
   "    .+    .+. . . .+    ",
   "    .+    .+ + + +.+    ",
   "    .+    .+      .+    ",
   "    .+. . .+      .+    ",
   "    .+ + +.+      .+    ",
   "    .+    .+. . . .+    ",
   "    .+    .+ + + +.+    ",
   "    .+    .+      .+    ",
   "    .......+      .+    ",
   "    .+++++.+      .+    ",
   "    ...............+    ",
   "     +++++.+++++++.+    ",
   "          .........+    ",
   "           +++++++++    ",
   "                        "
   };

static char *close_pane_xpm[] = {
   "24 24 3 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "                        ",
   "                        ",
   "          .........     ",
   "          .+++++++.+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "          .+. . . .+    ",
   "          .+ + + +.+    ",
   "          .+      .+    ",
   "          .+      .+    ",
   "           +      .+    ",
   "     .    ..  . . .+    ",
   "     ..  ....  + +.+    ",
   "      .. ...++    .+    ",
   "      .....++     .+    ",
   "       ...++      .+    ",
   "       ....  ......+    ",
   "      ......  ++++.+    ",
   "      ..+....  ....+    ",
   "     ..++ ....  ++++    ",
   "     .++   ..++         ",
   "      +     ++          "
   };

static char *add_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #424242",
   "@      c #929292",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "        .............   ",
   "        . +++++++++ .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "          +       + .@  ",
   "       ..         + .@  ",
   "       ..@        + .@  ",
   "       ..@   ++++++ .@  ",
   "       ..@    .......@  ",
   "   .......... @@@@@@@@  ",
   "   ..........@          ",
   "    @@@..@@@@@          ",
   "       ..@              ",
   "       ..@              ",
   "       ..@              ",
   "        @@              "
   };

static char *clone_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #424242",
   "@      c #929292",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "   .............        ",
   "   . +++++++++ .@       ",
   "   . +  .............   ",
   "   . +  . +++++++++ .@  ",
   "   . +  . +       + .@  ",
   "   . +  . +       + .@  ",
   "   . +  . +       + .@  ",
   "   . +  . +       + .@  ",
   "   . +  . +       + .@  ",
   "   . +++. +       + .@  ",
   "   ...... +       + .@  ",
   "    @@@@. +++++++++ .@  ",
   "        .............@  ",
   "         @@@@@@@@@@@@@  ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        "
   };

static char *close_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #424242",
   "@      c #929292",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "        .............   ",
   "        . +++++++++ .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "        . +       + .@  ",
   "        .         + .@  ",
   "     .    ..      + .@  ",
   "     .. .....     + .@  ",
   "      ......@@+++++ .@  ",
   "      .....@@........@  ",
   "       ...@@  @@@@@@@@  ",
   "       ....             ",
   "      ......            ",
   "      ..@....           ",
   "     ..@@ ....          ",
   "     .@@   ..@@         ",
   "      @     @@          "
   };

static char *add_transverse_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #929292",
   "@      c #424242",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "            ... ...     ",
   "           .   .   .    ",
   "          .    .   ..   ",
   "          .         .+  ",
   "         .  @  .  @  .  ",
   "         .@@   .   @@.+ ",
   "         .  @     @  .+ ",
   "        .   @     @   . ",
   "                      .+",
   "       ..             .+",
   "       ..+     @      .+",
   "       ..+    @@@    .++",
   "       ..+     @     .+ ",
   "   ..........       .++ ",
   "   ..........+ .   .++  ",
   "    +++..+++++.+...++   ",
   "       ..+     +++++    ",
   "       ..+              ",
   "       ..+              ",
   "        ++              "
   };

static char *add_sagittal_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #424242",
   "@      c #929292",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "              ...       ",
   "            .. . ..     ",
   "          ..   +   ..   ",
   "         .     +     .  ",
   "         .     +     .@ ",
   "             .        . ",
   "       ..     ....    .@",
   "       ..@  ++    .   .@",
   "       ..@    +   .  .@@",
   "       ..@        ...@@ ",
   "   .......... ....@@@@  ",
   "   ..........@ @@@@     ",
   "    @@@..@@@@@          ",
   "       ..@              ",
   "       ..@              ",
   "       ..@              ",
   "        @@              "
   };

static char *add_coronal_view_xpm[] = {
   "24 24 4 1",
   "       c None",
   ".      c #000000",
   "+      c #424242",
   "@      c #929292",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "                        ",
   "            ... ...     ",
   "           .   .   .    ",
   "          .    .    .   ",
   "         ..  +   +  ..  ",
   "         .   ++ ++   .@ ",
   "        .      +      . ",
   "               +      .@",
   "       .. ..   +   .. .@",
   "       ..@  .     .  . @",
   "       ..@            . ",
   "       ..@     . +    .@",
   "   .......... .@.    .@@",
   "   ..........@ @ ....@@ ",
   "    @@@..@@@@@    @@@@  ",
   "       ..@              ",
   "       ..@              ",
   "       ..@              ",
   "        @@              "
   };

/* make a pixmap */
GtkWidget *create_pixmap(GtkWidget * widget, int pixmap_id)
{
   GtkWidget *pixmap;
   GdkColormap *colormap;
   GdkPixmap *gdkpixmap;
   GdkBitmap *mask;
   static char **xpm_ptr = NULL;

   switch (pixmap_id){
   case CHAIN_V_PIXMAP:
      xpm_ptr = chain_v_xpm;
      break;
   case LOCKED_PIXMAP:
      xpm_ptr = locked_xpm;
      break;
   case SLIDE_PIXMAP:
      xpm_ptr = slide_xpm;
      break;
   case CLOSE_PIXMAP:
      xpm_ptr = close_xpm;
      break;
   case ADD_PIXMAP:
      xpm_ptr = add_xpm;
      break;
   case CLONE_PIXMAP:
      xpm_ptr = clone_xpm;
      break;

   case TRANSLATION_PIXMAP:
      xpm_ptr = translation_xpm;
      break;
   case ROTATION_PIXMAP:
      xpm_ptr = rotation_xpm;
      break;
   case SCALE_PIXMAP:
      xpm_ptr = scale_xpm;
      break;
   case TILT_PIXMAP:
      xpm_ptr = tilt_xpm;
      break;

   case ORTHOGRAPHIC_PIXMAP:
      xpm_ptr = orthographic_xpm;
      break;
   case PERSPECTIVE_PIXMAP:
      xpm_ptr = perspective_xpm;
      break;
   case VOLUME_PIXMAP:
      xpm_ptr = volume_xpm;
      break;

   case ADD_PANE_PIXMAP:
      xpm_ptr = add_pane_xpm;
      break;
   case CLONE_PANE_PIXMAP:
      xpm_ptr = clone_pane_xpm;
      break;
   case CLOSE_PANE_PIXMAP:
      xpm_ptr = close_pane_xpm;
      break;
   case ADD_VIEW_PIXMAP:
      xpm_ptr = add_view_xpm;
      break;
   case ADD_TRANSVERSE_VIEW_PIXMAP:
      xpm_ptr = add_transverse_view_xpm;
      break;
   case ADD_SAGITTAL_VIEW_PIXMAP:
      xpm_ptr = add_sagittal_view_xpm;
      break;
   case ADD_CORONAL_VIEW_PIXMAP:
      xpm_ptr = add_coronal_view_xpm;
      break;
   case CLONE_VIEW_PIXMAP:
      xpm_ptr = clone_view_xpm;
      break;
   case CLOSE_VIEW_PIXMAP:
      xpm_ptr = close_view_xpm;
      break;

   default:
      g_error("create_pixmap passed non-existant pixmap id %d\n", pixmap_id);
      }

   colormap = gtk_widget_get_colormap(widget);
   gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, colormap, &mask,
                                                     NULL, xpm_ptr);

   pixmap = gtk_pixmap_new(gdkpixmap, mask);
   gdk_pixmap_unref(gdkpixmap);
   gdk_bitmap_unref(mask);
   return pixmap;
   }
